//More precise control over shadows and shaders!
//Made by Cruxeis, BL_ID 35041

$remapDivision[$remapCount] = "Better Shadow Control";
$remapName[$remapCount] = "Toggle BSC GUI";
$remapCmd[$remapCount] = "BSC_toggle";
$remapCount++;

%parent = OPT_ShaderQuality0.getGroup();
%button = new GuiBitmapButtonCtrl(BSC_optionsButton) {
   profile = "BlockButtonProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "110 50";
   extent = "70 30";
   minExtent = "8 2";
   enabled = "1";
   visible = "1";
   clipToParent = "1";
   command = "canvas.pushDialog(betterShadowControlGUI);";
   text = "Open BSC";
   groupNum = "-1";
   buttonType = "PushButton";
   bitmap = "base/client/ui/button2";
   lockAspectRatio = "0";
   alignLeft = "0";
   alignTop = "0";
   overflowImage = "0";
   mKeepCached = "0";
   mColor = "255 255 255 255";
};

%parent.add(%button);

function BSC_eReset()
{
	optionsDlg.setShaderQuality(0);
	canvas.popDialog(betterShadowControlGUI);
	deleteVariables("$BSC*");
	betterShadowControlGUI.delete();
	deactivatePackage(BSCPackage);
	exec("Add-Ons/Client_BetterShadowControl/client.cs");
	canvas.pushDialog(betterShadowControlGUI);
}

function BSC_toggle(%tog)
{
	if(!%tog)
		return;
	if(betterShadowControlGUI.isAwake())
		canvas.popDialog(betterShadowControlGUI);
	else
		canvas.pushDialog(betterShadowControlGUI);
}

function BSC_apply(%def, %type, %qual, %level, %dynamic, %splits)
{
	if(!%def && (%level $= "" || %level $= " " || %qual == 0))
	{
		optionsDlg.setShaderQuality(0);
		return;
	}
	if(%def)
	{
		switch$(%type)
		{
			case "gen":
				%opt = "BSC_gen";
				for(%i = 0; %i < 7; %i++)
					if((%opt @ %i).getValue())
						%final = %i;
			case "screen":
				%opt = "BSC_screen";
				for(%i = 0; %i < 7; %i++)
					if((%opt @ %i).getValue())
						%final = %i;
		}
		optionsDlg.setShaderQuality(%final);
		return;
	}
	$Shader::Enabled = 1;
	//thanks to zeblote for the 16384 part
	if(%qual > 16384)
		%qual = 16384;
	if(%qual >= 8000)
	{
		BSC_setShaderQuality(5000);
		for(%i = 0; %i < (%qual - 5000); %i += 500)
			BSC_setShaderQuality((%i += 5000));
	}
	else
		BSC_setShaderQuality(%qual);
	BSC_setShaderLevel(%level); 
	BSC_setDynamicShadows(%dynamic);
	BSC_setShadowSplits(%splits);
	initializeShaderAssets();
	regenerateShadowMapFBOs();
	flushVBOCache();
}

function BSC_setShaderQuality(%qual)
{
	if(%qual < 0)
		return;
	if(%qual < 1)
		return;
	$Shader::ShadowSize = %qual;
}

function BSC_setShaderLevel(%level)
{
	if(%level $= "" || %level $= " ")
		return;
	$Shader::ShaderName = %level;
}

function BSC_setDynamicShadows(%dynamic)
{
	switch(%dynamic)
	{
		case 0:
			for(%i = 0; %i < 4; %i++)
				$Shader::DynamicShadows[%i] = 0;
		case 1:
			$Shader::DynamicShadows0 = 1;
			for(%i = 1; %i < 4; %i++)
				$Shader::DynamicShadows[%i] = 0;
		case 2:
			$Shader::DynamicShadows0 = 1;
			$Shader::DynamicShadows1 = 1;
			$Shader::DynamicShadows2 = 0;
			$Shader::DynamicShadows3 = 0;
		case 3:
			for(%i = 0; %i < 3; %i++)
				$Shader::DynamicShadows[%i] = 1;
			$Shader::DynamicShadows3 = 0;
		case 4:
			for(%i = 0; %i < 4; %i++)
				$Shader::DynamicShadows[%i] = 1;
	}
}

function BSC_setShadowSplits(%val)
{
	if(%val > 4 || %val < 1)
		return;
	$Shader::ShadowCount = %val;
}

function BSC_keepgeneral(%keep)
{
	%opt = "BSC_screen";
	if(%keep)
	{
		for(%i = 0; %i < 7; %i++)
			(%opt @ %i).pushtoback(BSC_screenDefHideSwatch);
		BSC_screenDefHideSwatch.position = "31 254";
		BSC_screenDefHideSwatch.extent = "552 31";
		BSC_screen_useDefault.pushtoback(BSC_screenDefHideSwatch);
		BSC_swatch.setVisible(1);
		BSC_swatch.bringtofront(betterShadowControlGUI);
		BSC_newquality.pushtoback(betterShadowControlGUI);
		BSC_newlevel.pushtoback(betterShadowControlGUI);
		BSC_newdynamicshadows.pushtoback(betterShadowControlGUI);
		BSC_newsplits.pushtoback(betterShadowControlGUI);
		BSC_screen_useDefault(0);
		BSC_screen_useDefault.setValue(0);
		return;
	}
	BSC_swatch.setVisible(0);
	BSC_swatch.pushtoback(betterShadowControlGUI);
	for(%i = 0; %i < 7; %i++)
		(%opt @ %i).bringtofront(BSC_screenDefHideSwatch);
	BSC_screenDefHideSwatch.position = "106 254";
	BSC_screenDefHideSwatch.extent = "477 31";
	BSC_screen_useDefault.bringtofront(BSC_screenDefHideSwatch);
	BSC_newquality.bringtofront(betterShadowControlGUI);
	BSC_newlevel.bringtofront(betterShadowControlGUI);
	BSC_newdynamicshadows.bringtofront(betterShadowControlGUI);
	BSC_newsplits.bringtofront(betterShadowControlGUI);
	BSC_screen_useDefault(1);
	BSC_screen_useDefault.setValue(1);
}

function BSC_gen_useDefault(%use)
{
	%opt = "BSC_gen";
	if(%use)
	{
		BSC_genDefHideSwatch.setVisible(0);
		BSC_genDefHideSwatch.pushtoback(betterShadowControlGUI);
		for(%i = 0; %i < 7; %i++)
			(%opt @ %i).bringtofront(betterShadowControlGUI);
		BSC_genCusHideSwatch.setVisible(1);
		BSC_genCusHideSwatch.bringtofront(betterShadowControlGUI);
		BSC_quality.pushtoback(betterShadowControlGUI);
		BSC_level.pushtoback(betterShadowControlGUI);
		BSC_dynamicshadows.pushtoback(betterShadowControlGUI);
		BSC_splits.pushtoback(betterShadowControlGUI);
		return;
	}
	BSC_genDefHideSwatch.setVisible(1);
	BSC_genDefHideSwatch.bringtofront(betterShadowControlGUI);
	for(%i = 0; %i < 7; %i++)
		(%opt @ %i).pushtoback(betterShadowControlGUI);
	BSC_genCusHideSwatch.setVisible(0);
	BSC_genCusHideSwatch.pushtoback(betterShadowControlGUI);
	BSC_quality.bringtofront(betterShadowControlGUI);
	BSC_level.bringtofront(betterShadowControlGUI);
	BSC_dynamicshadows.bringtofront(betterShadowControlGUI);
	BSC_splits.bringtofront(betterShadowControlGUI);
}

function BSC_screen_useDefault(%use)
{
	%opt = "BSC_screen";
	if(%use)
	{
		BSC_screenDefHideSwatch.setVisible(0);
		BSC_screenDefHideSwatch.pushtoback(betterShadowControlGUI);
		for(%i = 0; %i < 7; %i++)
			(%opt @ %i).bringtofront(betterShadowControlGUI);
		BSC_screenCusHideSwatch.setVisible(1);
		BSC_screenCusHideSwatch.bringtofront(betterShadowControlGUI);
		BSC_newquality.pushtoback(betterShadowControlGUI);
		BSC_newlevel.pushtoback(betterShadowControlGUI);
		BSC_newdynamicshadows.pushtoback(betterShadowControlGUI);
		BSC_newsplits.pushtoback(betterShadowControlGUI);
		return;
	}
	BSC_screenDefHideSwatch.setVisible(1);
	BSC_screenDefHideSwatch.bringtofront(betterShadowControlGUI);
	for(%i = 0; %i < 7; %i++)
		(%opt @ %i).pushtoback(betterShadowControlGUI);
	BSC_screenCusHideSwatch.setVisible(0);
	BSC_screenCusHideSwatch.pushtoback(betterShadowControlGUI);
	BSC_newquality.bringtofront(betterShadowControlGUI);
	BSC_newlevel.bringtofront(betterShadowControlGUI);
	BSC_newdynamicshadows.bringtofront(betterShadowControlGUI);
	BSC_newsplits.bringtofront(betterShadowControlGUI);
}

package BSCpackage {
	
function doScreenshot(%tog)
{
	if(!($BSC_keepgeneral))
	{
		BSC_apply($BSC_screen_useDefault, "screen", $BSC_newquality, $BSC_newlevel, $BSC_newdynamicshadows, $BSC_newsplits);
		parent::doScreenshot(%tog);
		BSC_apply($BSC_gen_useDefault, "gen", $BSC_quality, $BSC_level, $BSC_dynamicshadows, $BSC_splits);
		return;
	}
	parent::doScreenshot(%tog);
}

function doDOFScreenshot(%tog)
{
	if(!($BSC_keepgeneral))
	{
		BSC_apply($BSC_screen_useDefault, "screen", $BSC_newquality, $BSC_newlevel, $BSC_newdynamicshadows, $BSC_newsplits);
		parent::doDOFScreenshot(%tog);
		BSC_apply($BSC_gen_useDefault, "gen", $BSC_quality, $BSC_level, $BSC_dynamicshadows, $BSC_splits);
		return;
	}
	parent::doDOFScreenshot(%tog);
}

function onExit()
{
	export("$BSC*", "config/BSC/config.cs");
	Parent::onExit();
}

};

activatePackage(BSCpackage);

for(%i = 0; %i < 5; %i++)
{
	BSC_dynamicshadows.add(%i, %i);
	BSC_newdynamicshadows.add(%i, %i);
}

BSC_dynamicshadows.setvalue(4);
BSC_newdynamicshadows.setvalue(4);

for(%i = 1; %i < 5; %i++)
{
	BSC_splits.add(%i, %i);
	BSC_newsplits.add(%i, %i);
}

BSC_splits.setvalue(4);
BSC_newsplits.setvalue(4);